import * as React from "react";
import { CB, IChannel, IPriority, ISchedulerProps, Q } from "./Types";
export declare class Scheduler extends React.Component<ISchedulerProps, {
    recalculate: number;
    queue: Q[];
    current: {
        ref: Q;
    };
}> {
    private queue;
    private timeout;
    private sortOnQ;
    private scheduledCallbacks;
    state: {
        recalculate: number;
        queue: Q[];
        current: {
            ref: any;
        };
    };
    componentWillUnmount(): void;
    componentDidUpdate(props: ISchedulerProps): void;
    update(): void;
    scheduleQ(when: number): void;
    add: (cb: CB, { priority, shift }: IPriority, ref: any) => Q;
    remove: (q: any) => void;
    replace: (q: any, cb: CB, { priority, shift }: IPriority, ref: any) => any;
    reset: () => void;
    schedule: (ref: any, cb: CB) => void;
    channel: IChannel;
    sortQ(): void;
    nextQ(): Q;
    executeQ(): void;
    noExecutedTask(): boolean;
    render(): React.ReactNode;
}
